/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class CenovyHandler extends DefaultHandler {
  private static final int VELIKOST_BUFFERU = 1000;

  private double celkovaCena;
  private StringBuffer hodnota = new StringBuffer(VELIKOST_BUFFERU);
  private boolean uvnitrVahy;
  private int jednotkovaCena;
  private double vaha;

  public double getCelkovaCena() {
    return celkovaCena;
  }
  
  public void startDocument() {
    celkovaCena = 0;
  }

  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    if (qName.equals("vaha") == true) {
      uvnitrVahy = true;                                
      hodnota.setLength(0);
    }
    else if (qName.equals("nazev") == true) {
      jednotkovaCena = Integer.parseInt(atts.getValue("jednotkovaCena"));      
    }
  }    

  public void endElement(String uri, String localName, 
                        String qName) {
    if (qName.equals("vaha") == true) {
      uvnitrVahy = false; 
      vaha = Double.parseDouble(hodnota.toString());        
    }
    else if (qName.equals("ovoce") == true) {
      celkovaCena += vaha * jednotkovaCena;        
    }
  }    

  public void characters(char[] ch, int start, int length) {
    if (uvnitrVahy == true) {  
      hodnota.append(ch, start, length);
    }        
  }
}
