/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class NazevHandler extends DefaultHandler {
  private static final int VELIKOST_BUFFERU = 100;

  private StringBuffer hodnota = new StringBuffer(VELIKOST_BUFFERU);
  private XMLReader parser;
  private ContentHandler dalsiHandler;
      
  private String nazev;
  private int jednotkovaCena;

  public NazevHandler(XMLReader parser,
                      ContentHandler dalsiHandler) {
    this.parser = parser;
    this.dalsiHandler = dalsiHandler;                    
  }
  
  public String getNazev() {
    return nazev;
  }
  
  public int getJednotkovaCena() {
    return jednotkovaCena; 
  }
    
  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    jednotkovaCena = Integer.parseInt(atts.getValue("jednotkovaCena"));
    hodnota.setLength(0);
  }    

  public void endElement(String uri, String localName, 
                         String qName) {
    nazev = hodnota.toString();
    parser.setContentHandler(dalsiHandler);
  }    

  public void characters(char[] ch, int start, int length) {
    hodnota.append(ch, start, length);
  }
}
