/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class OvoceHandler extends DefaultHandler {
  private static ArrayList<Ovoce> ar = new ArrayList<Ovoce>();
  private XMLReader parser;
  private NazevHandler nazevHandler;
  private VahaHandler vahaHandler;
      
  private int cislo;

  public OvoceHandler(XMLReader parser) {
    this.parser = parser;
    this.vahaHandler = new VahaHandler(parser, this);
    this.nazevHandler = new NazevHandler(parser, vahaHandler);
  }
  
  public ArrayList<Ovoce> getSeznam() {
    return ar;
  }
  
  public void startDocument() {
    ar.clear();
  }

  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    if (qName.equals("ovoce") == true) {
      cislo = Integer.parseInt(atts.getValue("cislo"));      
      parser.setContentHandler(nazevHandler);
    }
  }    

  public void endElement(String uri, String localName, 
                         String qName) {
    if (qName.equals("ovoce") == true) {
      ar.add(new Ovoce(cislo, nazevHandler.getNazev(),
                       nazevHandler.getJednotkovaCena(), 
                       vahaHandler.getVaha()));        
    }
  }    
}
