/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class VahaHandler extends DefaultHandler {
  private static final int VELIKOST_BUFFERU = 100;

  private StringBuffer hodnota = new StringBuffer(VELIKOST_BUFFERU);
  private XMLReader parser;
  private ContentHandler nadrazenyHandler;
      
  private double vaha;

  public VahaHandler(XMLReader parser,
                      ContentHandler nadrazenyHandler) {
    this.parser = parser;
    this.nadrazenyHandler = nadrazenyHandler;                    
  }
  
  public double getVaha() {
    return vaha;
  }
  
  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    hodnota.setLength(0);
  }    

  public void endElement(String uri, String localName, 
                         String qName) {
    vaha = Double.parseDouble(hodnota.toString());       
    parser.setContentHandler(nadrazenyHandler);
  }    

  public void characters(char[] ch, int start, int length) {
    hodnota.append(ch, start, length);
  }
}
