/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class VahovyHandler extends DefaultHandler {
  private static final int VELIKOST_BUFFERU = 10000;
  private static final String JMENO_ELEMENTU = "vaha";

  private double celkovaVaha;
  private StringBuffer hodnota = new StringBuffer(VELIKOST_BUFFERU);
  private boolean uvnitrVahy;

  public double getCelkovaVaha() {
    return celkovaVaha;
  }
  
  public void startDocument() {
    celkovaVaha = 0;
  }

  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    if (qName.equals(JMENO_ELEMENTU) == true) {
      System.out.print("<" + qName);
      uvnitrVahy = true;                                
      hodnota.setLength(0);
    }
  }    

  public void endElement(String uri, String localName, String qName) {
    if (qName.equals(JMENO_ELEMENTU) == true) {
      uvnitrVahy = false; 
      celkovaVaha += Double.parseDouble(hodnota.toString());        
      System.out.println(" " + hodnota + " " + qName + ">");
    }
  }    

  public void characters(char[] ch, int start, int length) {
    if (uvnitrVahy == true) {  
      System.out.print("CH=|" + new String(ch) + "|");
      hodnota.append(ch, start, length);
    }        
  }
}
