/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import javax.xml.parsers.*;

public class ValidatorSAX {

  public static void main(String[] args) {
    if (args.length < 1) {
      System.out.println("Syntaxe: java ValidatorSAX <soubor.xml> [dtd | xsd] [soubor.xsd]\n");
      System.exit(1);
    }
    
    boolean dtd = false;
    boolean xsd = false;
    if (args.length >= 2) {
      if (args[1].toLowerCase().equals("dtd") == true) {
        dtd = true;
      }
      else if (args[1].toLowerCase().equals("xsd") == true) {
        xsd = true;
      }
    }
    
    try {
      SAXParserFactory spf = SAXParserFactory.newInstance();
      spf.setValidating(true);
      spf.setFeature("http://xml.org/sax/features/namespaces", true);  
//      spf.setNamespaceAware(true);    // stejna akce
      if (dtd == false  &&  xsd == false) {
        spf.setValidating(false);
      }
      else if (xsd == true) {
        spf.setFeature("http://apache.org/xml/features/validation/schema", true);
      }

      SAXParser sp = spf.newSAXParser();

      if (xsd == true) {
        sp.setProperty("http://java.sun.com/xml/jaxp/properties/schemaLanguage",
                       "http://www.w3.org/2001/XMLSchema");
        if (args.length == 3) {
          sp.setProperty("http://java.sun.com/xml/jaxp/properties/schemaSource",
                       new File(args[2]));
        }
      }

      XMLReader parser = sp.getXMLReader();
      parser.setErrorHandler(new ValidaceChybyZjisteneParserem());
      PocetElementuHandler h = new PocetElementuHandler();
      parser.setContentHandler(h);

      parser.parse(args[0]);
      System.out.println(args[0] +": " + h.getVysledek());
    }
    catch (Exception e)
    {
      String s = e.getMessage();
      int i = s.indexOf(ValidaceChybyZjisteneParserem.KONEC);
      if (i > 0) { 
        s = s.substring(0, i);
      }
      System.out.println(s);
    }
  }
}

class PocetElementuHandler extends DefaultHandler {
  private int pocetElementu = 0;
  private int pocetAtributu = 0;

  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    pocetElementu++;
    pocetAtributu += atts.getLength();
  }          
  
  public String getVysledek() {
    return "" + pocetElementu + " elementu "
               + pocetAtributu + " atributu";
  }
}
