/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class VseVPametiHandler extends DefaultHandler {
  private static final int VELIKOST_BUFFERU = 100;

  private static ArrayList<Ovoce> ar = new ArrayList<Ovoce>();
  private StringBuffer hodnota = new StringBuffer(VELIKOST_BUFFERU);
  private boolean uvnitrElementu; 
      
  private int cislo;
  private String nazev;
  private int jednotkovaCena;
  private double vaha;

  public ArrayList<Ovoce> getSeznam() {
    return ar;
  }
  
  public void startDocument() {
    ar.clear();
  }

  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    if (qName.equals("ovoce") == true) {
      cislo = Integer.parseInt(atts.getValue("cislo"));      
    }
    else if (qName.equals("nazev") == true) {
      jednotkovaCena = Integer.parseInt(atts.getValue("jednotkovaCena"));
      hodnota.setLength(0);
      uvnitrElementu = true;
    }
    else if (qName.equals("vaha") == true) {
      hodnota.setLength(0);
      uvnitrElementu = true;
    }
  }    

  public void endElement(String uri, String localName, String qName) {
    if (qName.equals("vaha") == true) {
      vaha = Double.parseDouble(hodnota.toString());        
      uvnitrElementu = false;
    }
    else if (qName.equals("nazev") == true) {
      nazev = hodnota.toString();      
      uvnitrElementu = false;
    }
    else if (qName.equals("ovoce") == true) {
      ar.add(new Ovoce(cislo, nazev, jednotkovaCena, vaha));        
    }
  }    

  public void characters(char[] ch, int start, int length) {
    if (uvnitrElementu == true) {  
      hodnota.append(ch, start, length);
    }        
  }
}
