/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class VypisVsehoNSHandler extends DefaultHandler {
  private static int cisloStart = 0; 
  private static int cisloEnd = 0; 
  private static int cisloChar = 0; 

  public void startDocument() {
    System.out.println("Zacatek zpracovani");
  }
  public void endDocument() {
    System.out.println("Konec zpracovani");
  }

  public void startElement(String uri, String localName, 
                            String qName, Attributes atts) {
    cisloStart++;                                
    System.out.println("" + cisloStart + ". start uri=" + uri
                       + ", localName=" + localName
                       + ", qName=" + qName);
    for (int i = 0;  i < atts.getLength() ;  i++) {
      System.out.println("  " + "atts uri=" + atts.getURI(i)
                         + ", localName=" + atts.getLocalName(i)
                         + ", qName=" + atts.getQName(i)
                         + ", type=" + atts.getType(i)
                         + ", value=" + atts.getValue(i));
    }    
  }
  
  public void characters(char[] ch, int start, int length) {
    String s = new String(ch).substring(start, start + length);
    if (s.trim().length() == 0) {
      return;
    }        

    cisloChar++;  
    System.out.println("" + cisloChar + ". ch=" + s
                       + ", start=" + start
                       + ", length=" + length);
  }

  public void endElement(String uri, String localName, String qName) {
    cisloEnd++;                                
    System.out.println("" + cisloEnd + ". end    uri=" + uri
                       + ", localName=" + localName
                       + ", qName=" + qName);
  }
}
