/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          // kvuli vyjimkam

public class CenaJidloDOM {
  private static final String SOUBOR = "jidlo.xml";
//  private static final String SOUBOR = "jidlo-komentar.xml";

  public static void main(String[] args) {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
//      dbf.setIgnoringComments(true);
      DocumentBuilder builder = dbf.newDocumentBuilder();
      builder.setErrorHandler(new ChybyZjisteneParserem());

      // nacteni dokumentu do pameti
      Document doc = builder.parse(SOUBOR);
      System.out.println("Celkova cena: " + getCelkovaCena(doc));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private static double getCelkovaCena(Document doc) {
    NodeList nl = doc.getElementsByTagName("ovoce");
    double celkovaCena = 0.0;
    for (int i = 0;  i < nl.getLength();  i++) {
      Node e = nl.item(i);
      if (e.getNodeType() == Node.ELEMENT_NODE) {
        celkovaCena += getCenaOvoce(e);
      }
    }
    return celkovaCena;
  }

  private static int getJednotkovaCena(Node ovoce) {
    Node nazev = getNodePodleJmena(ovoce, "nazev");
    NamedNodeMap nnm = nazev.getAttributes();
    String hodnota = nnm.getNamedItem("jednotkovaCena").getNodeValue();
/*  druhy zpusob
    Attr a = ((Element) nazev).getAttributeNode("jednotkovaCena");
    String hodnota = a.getValue();
*/
    return Integer.parseInt(hodnota);   
  }
 
  private static double getCenaOvoce(Node ovoce) {
    double jednotkovaCena = getJednotkovaCena(ovoce);  
    Node vaha = getNodePodleJmena(ovoce, "vaha");
    Node text = getNodePodleJmena(vaha, "#text"); 
    String hodnota = text.getNodeValue().trim();
    return Double.parseDouble(hodnota) * jednotkovaCena;  
  }

  private static Node getNodePodleJmena(Node rodic, String jmeno) {
    NodeList nl = rodic.getChildNodes();
    for (int i = 0;  i < nl.getLength();  i++) {
      Node e = nl.item(i);
      if (e.getNodeName().equals(jmeno) == true) {
        return e;
      }
    }
    return null;
  }      
}
