/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import java.nio.charset.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import org.w3c.dom.traversal.*;

public class JednotneZarovnaniDOM {
  private static final String SOUBOR = "jidlo-neodsazene2.xml";
  private static final String VYSTUPNI_SOUBOR = "jidlo-odsazene.xml";

  public static void main(String[] args) {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
      DocumentBuilder builder = dbf.newDocumentBuilder();
      builder.setErrorHandler(new ChybyZjisteneParserem());
      Document doc = builder.parse(SOUBOR);

      odstranMezeryANoveRadky(doc);  
        
      TransformerFactory tf = TransformerFactory.newInstance();
      tf.setAttribute("indent-number", 2);	    
      Transformer zapisovac = tf.newTransformer();
      zapisovac.setOutputProperty(OutputKeys.INDENT, "yes"); 
      String kodovani = "windows-1250";
      zapisovac.setOutputProperty("encoding", kodovani);
      zapisovac.transform(new DOMSource(doc),
                          new StreamResult(
                          new OutputStreamWriter(
                          new FileOutputStream(
                          new File(VYSTUPNI_SOUBOR)), 
                          Charset.forName(kodovani))));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  public static void odstranMezeryANoveRadky(Document doc) {
    Node n = doc.getDocumentElement();
    NodeIterator ni = ((DocumentTraversal) doc).createNodeIterator(
         doc.getDocumentElement(), NodeFilter.SHOW_TEXT, 
         new PrazdnyText(), false);
    while ((n = ni.nextNode()) != null) {
      Node rodic = n.getParentNode();
      rodic.removeChild(n);        
    }  
  }

  private static class PrazdnyText implements NodeFilter {
    public short acceptNode(Node n) {
      if (n.getNodeValue().trim().length() == 0) {
        return NodeFilter.FILTER_ACCEPT;
      }
      else {
        return NodeFilter.FILTER_SKIP;
      }
    }  
  }
  
}
