/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.w3c.dom.traversal.*;
import org.xml.sax.*;          // kvuli vyjimkam

public class NodeIteratorDOM {
  private static final String SOUBOR = "jidlo.xml";

  public static void main(String[] args) {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
      DocumentBuilder builder = dbf.newDocumentBuilder();
      builder.setErrorHandler(new ChybyZjisteneParserem());
      Document doc = builder.parse(SOUBOR);

      // vypis vsech elementu a textu
      NodeIterator ni = ((DocumentTraversal) doc).createNodeIterator(
        doc.getDocumentElement(), 
        NodeFilter.SHOW_ELEMENT + NodeFilter.SHOW_TEXT,
        null, false);
      vypisSeznam(ni);  
     
      System.out.println("Filtrovany vystup");
      ni = ((DocumentTraversal) doc).createNodeIterator(
        doc.getDocumentElement(), 
        NodeFilter.SHOW_ELEMENT + NodeFilter.SHOW_TEXT,
        new Filtr(), false);
      vypisSeznam(ni);  
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private static void vypisSeznam(NodeIterator ni) {
    Node n;        
    while ((n = ni.nextNode()) != null) {
//    for (Node n : ni) {
      if (n.getNodeType() == Node.ELEMENT_NODE) {  
        System.out.print(n.getNodeName() + ": ");
      }
      else {
        System.out.println(n.getNodeValue());
      }
    }
  }
} 
  
class Filtr implements NodeFilter {
  public short acceptNode(Node n) {
    if (n.getNodeName().equals("ovoce") == true) {
      return NodeFilter.FILTER_SKIP;
    }
    else if (n.getNodeType() == Node.TEXT_NODE
              &&  n.getNodeValue().trim().length() == 0) {
      // odradkovani
      return NodeFilter.FILTER_SKIP;
    }
    return NodeFilter.FILTER_ACCEPT;
  }        
}      
