/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import java.nio.charset.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class NoveJidloDOM {
  private static final String VYSTUPNI_SOUBOR = "jidlo-nove.xml";

  public static void main(String[] args) {
    try {
      Document zdroj = vytvorDocument();

      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer zapisovac = tf.newTransformer();
      zapisovac.setOutputProperty(OutputKeys.INDENT, "yes"); 
      zapisovac.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");
      zapisovac.setOutputProperty(OutputKeys.ENCODING, "windows-1250");

      zapisovac.transform(new DOMSource(zdroj),
                          new StreamResult(
                          new File(VYSTUPNI_SOUBOR)));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  private static Document vytvorDocument() throws Exception {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    dbf.setValidating(false);
    DocumentBuilder builder = dbf.newDocumentBuilder();
    DOMImplementation impl = builder.getDOMImplementation();
    Document doc = impl.createDocument(null, "jidlo", null);
    Node jidlo = doc.getDocumentElement();
      
    Element ovoce = doc.createElement("ovoce");
    ovoce.setAttribute("cislo", "10");  
    Element nazev = doc.createElement("nazev");
    nazev.setAttribute("jednotkovaCena", "30");  
    Text textNazev = doc.createTextNode("vestky");
    nazev.appendChild(textNazev);
    Element vaha = doc.createElement("vaha");
    Text textVaha = doc.createTextNode("1.5");
    vaha.appendChild(textVaha);

    ovoce.appendChild(nazev);
    ovoce.appendChild(vaha);

    Element ovoceKlon = (Element) ovoce.cloneNode(true);
    jidlo.appendChild(ovoce);
    jidlo.appendChild(ovoceKlon);
    return doc;
  }
}
