/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import java.nio.charset.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class OdsazovaniVystupuDOM1_5 {
  private static final String SOUBOR = "jidlo-neodsazene2.xml";
  private static final String VYSTUPNI_SOUBOR = "jidlo-odsazene.xml";

  public static void main(String[] args) {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
      DocumentBuilder builder = dbf.newDocumentBuilder();
      builder.setErrorHandler(new ChybyZjisteneParserem());
      Document doc = builder.parse(SOUBOR);

      TransformerFactory tf = TransformerFactory.newInstance();
      tf.setAttribute("indent-number", new Integer(2));  
      Transformer zapisovac = tf.newTransformer();
      zapisovac.setOutputProperty(OutputKeys.INDENT, "yes"); 
// JDK 1.4     zapisovac.setOutputProperty("{http://xml.apache.org/xalan}indent-amount", "2");	    
//      String kodovani = "windows-1250";
      String kodovani = "UTF-8";
      zapisovac.setOutputProperty("encoding", kodovani);
      System.out.println(zapisovac.getOutputProperties());  

      OutputStreamWriter osw = new OutputStreamWriter(
                               new FileOutputStream(
                               new File(VYSTUPNI_SOUBOR)), 
                               Charset.forName(kodovani));
      zapisovac.transform(new DOMSource(doc), new StreamResult(osw));
      osw.close();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
