/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import org.xml.sax.*;

public class PocitadloDOM
{
  // hlavn program
  public static void main(String[] args)
  {
    // kontrola vstupnch parametr
    if (args.length != 2)
    {
      System.out.println("patn poet parametr!\n");
      System.out.println("Syntaxe: java ObsluhaChyb <soubor> <nzev elementu>\n");
      System.exit(1);
    }

    try
    {
      // vytvoen DocumentBuilderu
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = dbf.newDocumentBuilder();

      // nastaven tdy pro obsluhu chyb
      builder.setErrorHandler(new MyErrorHandler());

      // naten dokumentu do pamti
      System.out.println("builder" + builder);
      long zac = System.currentTimeMillis();
      Document doc = builder.parse(args[0]);

      System.out.println("Poet element '" + args[1] + "' v dokumentu: " +
        doc.getDocumentElement().getElementsByTagName(args[1]).getLength());
      long kon = System.currentTimeMillis();
      System.out.println("" + (kon - zac));
    }
    // zachycen vjimek
    catch (ParserConfigurationException e)
    {
      // Chyby vznikl pi nastavovn vlastnost parseru
      System.out.println(e.getMessage());
    }
    catch (SAXException e)
    {
      // Chyby vznikl pi parsovn XML dokumentu
      System.out.println(e.getMessage());
    }
    catch (IOException e)
    {
      // Chyby vznikl pi ten XML z njakho souboru nebo ze st
      System.out.println(e.getMessage());
    }
  }

  // tda definujc obsluhu chyb
  private static class MyErrorHandler implements ErrorHandler
  {

    // zformtovn chybovho hlen
    private String getParseExceptionInfo(SAXParseException e)
    {
      return "URI: " + e.getSystemId() + "\n" +
             "dka: " + e.getLineNumber() + " Znak: " +
             e.getColumnNumber() + "\n" +
             e.getMessage();
    }

    // obsluha chyb v dokumentu
    public void error (SAXParseException e) throws SAXException
    {
      throw new SAXException("Chyba: " + getParseExceptionInfo(e));
    }

    // obsluha fatlnch chyb v dokumentu
    public void fatalError (SAXParseException e) throws SAXException
    {
      throw new SAXException("Fatln chyba: " + getParseExceptionInfo(e));
    }

    // obsluha varovnch hlen od parseru
    public void warning (SAXParseException e)
    {
      System.out.println("Varovn: " + getParseExceptionInfo(e));
    }
  }
}