/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import org.w3c.dom.traversal.*;
import org.w3c.dom.ls.*;
import org.xml.sax.*;

public class PruchodDOM {
  static int hloubkaRekurze = 0;
  // hlavn program
  public static void main(String[] args)
  {
    // kontrola vstupnch parametr
    if (args.length != 1) {
      System.out.println("patn poet parametr!\n");
      System.out.println("Syntaxe: java PruchodDOM <soubor>\n");
      System.exit(1);
    }

    try {
      // vytvoen DocumentBuilderu
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
      dbf.setIgnoringElementContentWhitespace(true);
      DocumentBuilder builder = dbf.newDocumentBuilder();

      // nastaven tdy pro obsluhu chyb
//      builder.setErrorHandler(new ObsluhaChyb());

      // naten dokumentu do pamti
      long zac = System.currentTimeMillis();
      Document doc = builder.parse(args[0]);
      long kon = System.currentTimeMillis();
      System.out.println("" + (kon - zac));

      NodeList ndl = doc.getDocumentElement().getChildNodes();
      for (int i = 0;  i < ndl.getLength();  i++) {
        System.out.println("" + i + ": " + ndl.item(i).getNodeName() 
                           + "|" + ndl.item(i).getNodeValue() + "|");
      }
      
      System.out.println();
      ndl = doc.getDocumentElement().getElementsByTagName("krestni");
      for (int i = 0;  i < ndl.getLength();  i++) {
        System.out.println("" + i + ": " + ndl.item(i).getNodeName() 
                           + "|" + ndl.item(i).getNodeValue() + "|");
      }

      System.out.println();
      ndl = doc.getDocumentElement().getElementsByTagName("krestni");
      for (int i = 0;  i < ndl.getLength();  i++) {
        System.out.println("" + i + "|"  
                           + ndl.item(i).getFirstChild().getNodeValue() 
                           + "|");
      }

      System.out.println();
      rekurze(doc.getDocumentElement());
      
      System.out.println();
      Node n;
      NodeIterator ni = ((DocumentTraversal) doc).createNodeIterator(
       doc.getDocumentElement(), NodeFilter.SHOW_TEXT, null, true);
      while ((n = ni.nextNode()) != null) {
        System.out.println(n.getNodeName() 
                        + "|" + n.getNodeValue() + "|");
      }

      System.out.println();
      ni = ((DocumentTraversal) doc).createNodeIterator(
         doc.getDocumentElement(), NodeFilter.SHOW_TEXT, 
         new NeprazdnyText(), true);
      while ((n = ni.nextNode()) != null) {
        System.out.println(n.getNodeName() 
                        + "|" + n.getNodeValue() + "|");
      }

      System.out.println();
      n = doc.getDocumentElement();
      ni = ((DocumentTraversal) doc).createNodeIterator(
         n, NodeFilter.SHOW_ELEMENT, null, true);
      while ((n = ni.nextNode()) != null) {
        if (n.hasAttributes() == true) {
          NamedNodeMap nm = n.getAttributes();
          Node an = nm.item(0);
          System.out.println(an.getNodeName() 
                        + "|" + an.getNodeValue() + "|");
        }
      }


    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private static class NeprazdnyText implements NodeFilter {
    public short acceptNode(Node n) {
      if (n.getNodeValue().trim().length() > 0) {
        return NodeFilter.FILTER_ACCEPT;
      }
      else {
        return NodeFilter.FILTER_SKIP;
      }
    }  
  }
  
  public static void rekurze(Node n) {
    for (int i = 0;  i < hloubkaRekurze;  i++) {
      System.out.print("  ");
    }
    System.out.print(hloubkaRekurze + ">"); 
    System.out.println(n.getNodeName() 
                        + "|" + n.getNodeValue() + "|");
    if (n.hasChildNodes() == false) {
      return; 
    }
    
    hloubkaRekurze++;
    NodeList ndl = n.getChildNodes();
    for (int i = 0;  i < ndl.getLength();  i++) {
      rekurze(ndl.item(i));
    }
    hloubkaRekurze--;
  }
}
