/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.w3c.dom.traversal.*;
import org.xml.sax.*;          // kvuli vyjimkam

public class TreeWalkerDOM {
  private static final String SOUBOR = "jidlo.xml";

  public static void main(String[] args) {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
      DocumentBuilder builder = dbf.newDocumentBuilder();
      builder.setErrorHandler(new ChybyZjisteneParserem());
      Document doc = builder.parse(SOUBOR);

      // vypis pouze vseho textu
      TreeWalker tw = ((DocumentTraversal) doc).createTreeWalker(
        doc.getDocumentElement(), 
        NodeFilter.SHOW_TEXT,
        null, false);
      vypisSeznam(tw);  
     
      System.out.println("Filtrovany vystup");
      tw = ((DocumentTraversal) doc).createTreeWalker(
        doc.getDocumentElement(), 
        NodeFilter.SHOW_TEXT,
        new FiltrNazvu(), false);
      vypisSeznam(tw);  
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private static void vypisSeznam(TreeWalker tw) {
    Node n;        
    while ((n = tw.nextNode()) != null) {
      System.out.println(n.getNodeValue());
    }
  }
} 
  
class FiltrNazvu implements NodeFilter {
  public short acceptNode(Node n) {
    if (n.getParentNode().getNodeName().equals("nazev") == true) {
      // je to textovy nod v elementu <nazev>
      if (n.getNodeValue().trim().length() != 0) {
        // neni to odradkovaci nod
        return NodeFilter.FILTER_ACCEPT;
      }
    }
    return NodeFilter.FILTER_SKIP;
  }        
}      
