/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.util.*;
import org.w3c.dom.*;

public class UlozeniDoPameti {
  private static ArrayList<Ovoce> ar = new ArrayList<Ovoce>();

  public static ArrayList<Ovoce> getSeznam(Document doc) {
    NodeList nl = doc.getElementsByTagName("ovoce");
    for (int i = 0;  i < nl.getLength();  i++) {
      Node e = nl.item(i);
//      if (e.getNodeType() == Node.ELEMENT_NODE) {
        ar.add(vytvorOvoce(e));
//      }
    }
    return ar;
  }

  private static Ovoce vytvorOvoce(Node ovoce) {
    String hodnota = ((Element) ovoce).getAttributeNode("cislo").getValue();
    int cislo = Integer.parseInt(hodnota);
    int jednotkovaCena = getJednotkovaCena(ovoce);  
    String nazev = getNazev(ovoce);
    double vaha = getVahaOvoce(ovoce); 
    return new Ovoce(cislo, nazev, jednotkovaCena, vaha);         
  }
  
  private static int getJednotkovaCena(Node ovoce) {
    Node nazev = getNodePodleJmena(ovoce, "nazev");
    NamedNodeMap nnm = nazev.getAttributes();
    String hodnota = nnm.getNamedItem("jednotkovaCena").getNodeValue();
    return Integer.parseInt(hodnota);  
  }
 
  private static String getNazev(Node ovoce) {
    Node nazev = getNodePodleJmena(ovoce, "nazev");
    Node text = getNodePodleJmena(nazev, "#text"); 
    return text.getNodeValue();  
  }
 
  private static double getVahaOvoce(Node ovoce) {
    Node vaha = getNodePodleJmena(ovoce, "vaha");
    Node text = getNodePodleJmena(vaha, "#text"); 
    String hodnota = text.getNodeValue().trim();
    return Double.parseDouble(hodnota);  
  }

  private static Node getNodePodleJmena(Node rodic, String jmeno) {
    NodeList nl = rodic.getChildNodes();
    for (int i = 0;  i < nl.getLength();  i++) {
      Node e = nl.item(i);
      if (e.getNodeName().equals(jmeno) == true) {
        return e;
      }
    }
    return null;
  }      
}
