/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          // kvuli vyjimkam

public class VahaJidloBezpecneDOM {
  private static final String SOUBOR = "jidlo-komentar.xml";

  public static void main(String[] args) {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
      DocumentBuilder builder = dbf.newDocumentBuilder();
      builder.setErrorHandler(new ChybyZjisteneParserem());

      // nacteni dokumentu do pameti
      Document doc = builder.parse(SOUBOR);
      System.out.println("Celkova vaha: " + getCelkovaVaha(doc));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private static double getCelkovaVaha(Document doc) {
    NodeList nl = doc.getElementsByTagName("vaha");
    double celkovaVaha = 0.0;
    for (int i = 0;  i < nl.getLength();  i++) {
      Node e = nl.item(i);          // Element
      NodeList nle = e.getChildNodes();
      String s = "";
      for (int j = 0;  j < nle.getLength();  j++) {
        if (nle.item(j).getNodeType() == Node.TEXT_NODE) {
          Node t = nle.item(j);                // Text
          s += t.getNodeValue().trim();
        }        
      }        
      if (s.length() > 0) {
        celkovaVaha += Double.parseDouble(s);
      } 
    }
    return celkovaVaha;
  }
}
