/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          
import javax.xml.*;
import javax.xml.validation.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class ValidaceJidloDOM1_6 {
  private static final String SOUBOR = "jidlo.xml";
//  private static final String SOUBOR = "jidlo-chyba-validace.xml";
  private static final String VALIDACNI_SOUBOR = "jidlo.xsd";

  public static void main(String[] args) throws Exception {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setNamespaceAware(true); 
//      dbf.setNamespaceAware(false); 
      DocumentBuilder builder = dbf.newDocumentBuilder();
      Document zdroj = builder.parse(SOUBOR);

      SchemaFactory sf = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
      Schema sch = sf.newSchema(new File(VALIDACNI_SOUBOR));
      Validator val = sch.newValidator();
      val.setErrorHandler(new ValidaceChybyZjisteneParserem());
      val.validate(new DOMSource(zdroj)); 
      System.out.println("Validace probehla uspesne");
    }
    catch (SAXException e) {
      System.out.println("Chyba validace:");
//      e.printStackTrace();
      
      String s = e.getMessage();
      int i = s.indexOf(ValidaceChybyZjisteneParserem.KONEC);
      if (i > 0) { 
        s = s.substring(0, i);
      }
      System.out.println(s);        
        
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
