/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          
import javax.xml.*;
import javax.xml.validation.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class ValidaceNoveJidloDOM1_6 {
  private static final String VALIDACNI_SOUBOR = "jidlo.xsd";

  public static void main(String[] args) throws Exception {
    try {
      Document zdroj = vytvorDocument();
      Reader r = konverze(zdroj);

      SchemaFactory sf = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
      Schema sch = sf.newSchema(new File(VALIDACNI_SOUBOR));
      Validator val = sch.newValidator();
      val.setErrorHandler(new ValidaceChybyZjisteneParserem());
      val.validate(new StreamSource(r)); 
//      val.validate(new DOMSource(zdroj)); 
      System.out.println("Validace probehla uspesne");
    }
    catch (SAXException e) {
      System.out.println("Chyba validace:");
//      e.printStackTrace();
      
      String s = e.getMessage();
      int i = s.indexOf(ValidaceChybyZjisteneParserem.KONEC);
      if (i > 0) { 
        s = s.substring(0, i);
      }
      System.out.println(s);        
        
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  private static Reader konverze(Document zdroj) {
    try {
      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer zapisovac = tf.newTransformer();
      zapisovac.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
      StringWriter sw = new StringWriter();
      StreamResult stres = new StreamResult(sw);
      zapisovac.transform(new DOMSource(zdroj),
                          stres);
      return new StringReader(sw.toString());
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return null;
  }  
    
  private static Document vytvorDocument() throws Exception {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
//    dbf.setNamespaceAware(true); 
    dbf.setValidating(false);
    DocumentBuilder builder = dbf.newDocumentBuilder();
    DOMImplementation impl = builder.getDOMImplementation();
    Document doc = impl.createDocument(null, "jidlo", null);
    Node jidlo = doc.getDocumentElement();
      
    Element ovoce = doc.createElement("ovoce");
    ovoce.setAttribute("cislo", "10");  
//    ovoce.setAttribute("cislo", "ABC10");    // chybna hodnota atributu
    Element nazev = doc.createElement("nazev");
    nazev.setAttribute("jednotkovaCena", "30");  
    Text textNazev = doc.createTextNode("vestky");
    nazev.appendChild(textNazev);
    Element vaha = doc.createElement("vaha");
    Text textVaha = doc.createTextNode("1.5");
    vaha.appendChild(textVaha);

    ovoce.appendChild(nazev);
    ovoce.appendChild(vaha);

    Element ovoceKlon = (Element) ovoce.cloneNode(true);
    jidlo.appendChild(ovoce);
    jidlo.appendChild(ovoceKlon);
    return doc;
  }
}
