/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

/**
* @author Pavel Herout
*/

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;          
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class ZmenaJidloDOM {
  private static final String SOUBOR = "jidlo.xml";
  private static final String VYSTUPNI_SOUBOR = "jidlo-zmena.xml";

  public static void main(String[] args) {
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      dbf.setValidating(false);
      DocumentBuilder builder = dbf.newDocumentBuilder();
      builder.setErrorHandler(new ChybyZjisteneParserem());
      Document doc = builder.parse(SOUBOR);

      zmenDokument(doc);
        
      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer zapisovac = tf.newTransformer();
      zapisovac.setOutputProperty(OutputKeys.ENCODING, "windows-1250");
      zapisovac.transform(new DOMSource(doc),
                          new StreamResult(
                          new File(VYSTUPNI_SOUBOR)));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private static void zmenDokument(Document doc) {
    Node jidlo = doc.getDocumentElement();

      // odstraneni <ovoce cislo="1">
    NodeList nl = doc.getElementsByTagName("ovoce");
    Node ovoce1 = nl.item(0);
    jidlo.removeChild(ovoce1);

    // odstraneni atributu cislo="2"
    Element ovoce2 = (Element) nl.item(0);
    ovoce2.removeAttribute("cislo");

    // zmena jednotkovaCena="25" na "15"
    NodeList nlNazev = doc.getElementsByTagName("nazev");
    Element nazev = (Element) nlNazev.item(0);
    nazev.setAttribute("jednotkovaCena", "15");  

    // pridani atributu <vaha jednotka="kg">2</vaha>
    NodeList nlVaha = doc.getElementsByTagName("vaha");
    Element vaha = (Element) nlVaha.item(0);
    vaha.setAttribute("jednotka", "kg");  

    // pridani elementu <vzhled>cerstvy & vonavy</vzhled>
    Element vzhled = doc.createElement("vzhled");
    Text text = doc.createTextNode("erstv & voav");
    ovoce2.appendChild(vzhled);
    vzhled.appendChild(text);

    // odradkovani za elementem </vzhled>
    Text textCRLF = doc.createTextNode("\n  ");
    ovoce2.appendChild(textCRLF);
  }
}
