/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import java.util.*;
import javax.xml.stream.*;
import javax.xml.transform.*;
import javax.xml.transform.stax.*;
import javax.xml.transform.stream.*;

public class JidloStAXWriteTransformer {
  public static final String SOUBOR = "jidlo-generovano2.xml";
  public static final int POCET = 3;

  public static void main(String[] args) {
    try {
      Random r = new Random();
      String kodovani = "UTF-8";
      XMLOutputFactory fo = XMLOutputFactory.newInstance();
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      XMLStreamWriter w = fo.createXMLStreamWriter(baos, kodovani);

      w.writeStartDocument(kodovani, "1.0");
      w.writeComment(" pehled makovnch dobrtek ");
      w.writeStartElement("jidlo");        
      for (int i = 1;  i <= POCET;  i++) {
        w.writeStartElement("ovoce");        
        w.writeAttribute("cislo", "" + i);        
        w.writeStartElement("nazev");        
        int cena = r.nextInt(40) + 10;
        w.writeAttribute("jednotkovaCena", "" + cena);
        String nazev = "ovoce " + i + " & <";
        w.writeCharacters(nazev);          
        w.writeEndElement();        
        w.writeStartElement("vaha"); 
        double vaha = r.nextDouble() * 10.0;
        String oriznute = String.valueOf(vaha).substring(0, 3);          
        w.writeCharacters(oriznute);          
        w.writeEndElement();        
        w.writeEndElement();        
      }
      w.writeEndElement();        
      w.writeEndDocument();
      w.close();

      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer zapisovac = tf.newTransformer();
      zapisovac.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "no");
      zapisovac.setOutputProperty(OutputKeys.ENCODING, kodovani);
//      zapisovac.setOutputProperty(OutputKeys.STANDALONE, "yes");
      zapisovac.setOutputProperty(OutputKeys.INDENT, "yes"); 
      zapisovac.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");
      
      ByteArrayInputStream bais = new ByteArrayInputStream(baos.toByteArray());
      XMLInputFactory fi = XMLInputFactory.newInstance();
      XMLStreamReader sr = fi.createXMLStreamReader(bais);
      zapisovac.transform(new StAXSource(sr),
                          new StreamResult(
                          new File(SOUBOR)));
      
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
