/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import java.util.*;
import javax.xml.stream.*;

public class VseVPametiStAX {
  public static final String SOUBOR = "jidlo.xml";

  public static void main(String[] args) {
    try {
      XMLInputFactory f = XMLInputFactory.newInstance();
      XMLStreamReader r = f.createXMLStreamReader(new FileReader(SOUBOR));

      ArrayList<Ovoce> ar = getSeznam(r);
      ZpracovaniDatVPameti.tiskniVse(ar);
      System.out.println("Celkova vaha = "
      		+ ZpracovaniDatVPameti.celkovaVaha(ar));
      System.out.println("Celkova cena = "
      		+ ZpracovaniDatVPameti.celkovaCena(ar));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  static ArrayList<Ovoce> getSeznam(XMLStreamReader r) throws Exception {
  	ArrayList<Ovoce> ar = new ArrayList<Ovoce>();
    int    cislo = 0;
    String nazev = null;
    int    jednotkovaCena = 0;;
    double vaha = 0;

    while (r.hasNext() == true) {
      r.next();
      if (r.isStartElement() == true) {
       	if (r.getLocalName().equals("ovoce") == true) {
          String c = r.getAttributeValue(null, "cislo");
          cislo = Integer.parseInt(c);
        }
        else if (r.getLocalName().equals("nazev") == true) {
          String a = r.getAttributeValue(null, "jednotkovaCena");
          jednotkovaCena = Integer.parseInt(a);
          nazev = r.getElementText();
        }
        else if (r.getLocalName().equals("vaha") == true) {
          String v = r.getElementText();
          vaha = Double.parseDouble(v);
        }
      }
      if (r.isEndElement() == true
         && r.getLocalName().equals("ovoce") == true) {
      	ar.add(new Ovoce(cislo, nazev, jednotkovaCena, vaha));        
      }
    }
    
    return ar;
  }
}
