/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import java.math.*;
import java.util.*;
import javax.xml.bind.*;
import jidlobalik.*;

public class JidloWriteJAXB {
  public static final String VYSTUP = "jidlo-generovano.xml";
  public static final int POCET = 3;

  public static void main(String[] args) {
    try {
      Random r = new Random();
      JAXBContext jc = JAXBContext.newInstance("jidlobalik");

      ObjectFactory of = new ObjectFactory();

      // vyrobeni noveho jidla -- korenovy element
      JidloType jidlo = (JidloType) of.createJidloType(); 
      List<OvoceType> seznamOvoce = jidlo.getOvoce();
      
      // vyrobeni ovoci
      for (int i = 1;  i <= POCET;  i++) {
        OvoceType o = of.createOvoceType();
        o.setCislo(new BigInteger(String.valueOf(i)));
        NazevType n = of.createNazevType();
        int cena = r.nextInt(40) + 10;
        n.setJednotkovaCena(new BigInteger(String.valueOf(cena)));
        String nazev = "ovoce " + i + " & <";
        n.setValue(nazev);
        o.setNazev(n);
        double vaha = r.nextDouble() * 10.0;
        String oriznute = String.valueOf(vaha).substring(0, 3);          
        o.setVaha(Double.parseDouble(oriznute));
        seznamOvoce.add(o);
      }
      
      Marshaller m = jc.createMarshaller();
      m.setProperty(Marshaller.JAXB_ENCODING, "windows-1250");
      m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
      m.setProperty(Marshaller.JAXB_NO_NAMESPACE_SCHEMA_LOCATION, "jidlo.xsd"); 
 
      // element pro Marshaller
      JAXBElement element = of.createJidlo(jidlo);
      m.marshal(element, new FileOutputStream(VYSTUP));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
