/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import java.math.*;
import java.util.*;
import javax.xml.bind.*;
import javax.xml.bind.util.JAXBSource;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Schema;
import javax.xml.validation.Validator;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.XMLConstants;
import org.xml.sax.*;
import jidlobalik.*;

public class ValidaceJAXB {
  public static final String BALIK = "jidlobalik";
  public static final String VSTUP = "jidlo.xml";
  public static final String SCHEMA = "jidlo.xsd";

  public static void main(String[] args) {
    try {
      SchemaFactory sf = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
      Source souborSchema = new StreamSource(new File(SCHEMA));
      Schema schemaXSD = sf.newSchema(souborSchema);

      javax.xml.validation.Validator validator = schemaXSD.newValidator();
      validator.setErrorHandler(new ChybyZjisteneValidatorem());

      JAXBContext jc = JAXBContext.newInstance(BALIK);
      Unmarshaller u = jc.createUnmarshaller();
      JAXBElement element = (JAXBElement) u.unmarshal(
                            new File(VSTUP));

      JidloType jidlo = (JidloType) element.getValue(); 
      List<OvoceType> seznamOvoce = jidlo.getOvoce();
      
      // chybna zmena vahy grapefruitu
      for (OvoceType o: seznamOvoce) {
        String nazev = o.getNazev().getValue();
        if (nazev.equals("grapefruity") == true) {
          o.setVaha(-1.0);
        }
      }

      // validace objektu v pameti
      JAXBSource pamet = new JAXBSource(jc, element);
      validator.validate(pamet);
    }
    catch (Exception e) {
      System.out.println(e.getMessage());
    }
  }
}

class ChybyZjisteneValidatorem implements ErrorHandler {
  public void generuj(String kategorie, SAXException e) throws SAXException {
    throw new SAXException(kategorie + ": " + e.toString());
  }
  
  public void warning(SAXParseException e) throws SAXException {
    generuj("Varovani", e);
  }

  public void error(SAXParseException e) throws SAXException {
    generuj("Chyba", e);
  }

  public void fatalError(SAXParseException e) throws SAXException {
    generuj("Fatalni chyba", e);
  }
}
