/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                       Java a XML                            //
//                       I. vydn                             //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      //
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2007                      //
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import java.math.*;
import java.util.*;
import javax.xml.bind.*;
import javax.xml.bind.util.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

import jidlobalik.*;

public class ZmenaAZapisJAXBTransform {
  public static final String BALIK = "jidlobalik";
  public static final String VSTUP = "jidlo.xml";
  public static final String VYSTUP = "jidlo-zmena.xml";
  public static final String SCHEMA = "jidlo.xsd";

  public static void main(String[] args) {
    try {
      JAXBContext jc = JAXBContext.newInstance(BALIK);
      Unmarshaller u = jc.createUnmarshaller();
      JAXBElement element = (JAXBElement) u.unmarshal(
                            new File(VSTUP));

      JidloType jidlo = (JidloType) element.getValue(); 
      ArrayList<OvoceType> seznamOvoce = 
         (ArrayList<OvoceType>) jidlo.getOvoce();
      
      // zmena ceny jablek
      for (OvoceType o: seznamOvoce) {
        String nazev = o.getNazev().getValue();
        if (nazev.equals("jablka") == true) {
          o.getNazev().setJednotkovaCena(new BigInteger("43"));
        }    
      }

      // vyrobeni noveho ovoce
      ObjectFactory of = new ObjectFactory();
      OvoceType noveOvoce = of.createOvoceType();
      noveOvoce.setCislo(new BigInteger("5"));
      NazevType n = of.createNazevType();
      n.setJednotkovaCena(new BigInteger("33"));
      n.setValue("broskve");
      noveOvoce.setNazev(n);
      noveOvoce.setVaha(3.1);
      
      // pridani noveho ovoce
      seznamOvoce.add(0, noveOvoce);
      
      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer zapisovac = tf.newTransformer();
      zapisovac.setOutputProperty(OutputKeys.INDENT, "yes"); 
      zapisovac.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");
      zapisovac.setOutputProperty(OutputKeys.ENCODING, "windows-1250");

      zapisovac.transform(new JAXBSource(jc, element),
                          new StreamResult(
                          new File(VYSTUP)));

    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
